/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.commands;


import org.eclipse.draw2d.geometry.Point;
import org.eclipse.swt.widgets.Shell;

import VOCLModel.Constraint;
import VOCLModel.VOCLDiagram;

import vocleditor.VOCLEditorPlugin;

/**
 * Command for creating a asscociation role.
 * @author bjoern
 */
public class CreateConstraintCommand extends org.eclipse.gef.commands.Command {
	private	Constraint constraint;
	private Point loc;
	private VOCLDiagram parent;
	private Shell shell;
	
	/**
	 * The default constructor.
	 */	
	public CreateConstraintCommand() 
	{
		VOCLEditorPlugin.printDebug( "NEW CREATE_CONSTRAINT_COMMAND");
		setLabel("create constraint");
	}
	
	/**
	 * Entry point for command execution.
	 */
	public void execute() 
	{   
		VOCLEditorPlugin.printDebug( "POPUP CONSTRAINT DIALOG !!!!!!");
		
		parent.getConstraints().add(constraint);
		if (loc != null) {
			constraint.setX(loc.x);
			constraint.setY(loc.y);
		}	
	}
	
	/**
	 * Redo command execution.
	 */
	public void redo() {
		parent.getConstraints().add( constraint );
	}
	
	/**
	 * Undo command execution.
	 */
	public void undo() {
		parent.getConstraints().remove( constraint );
	}	
	
	/**
	 * Returns the parent vocl diagramm.
	 * @return the parent vocl diagramm
	 */
	public VOCLDiagram getParent() {
		return parent;
	}
	
	/**
	 * Sets the parent vocl diagramm.
	 * @param newParent the parent vocl diagramm to set
	 */
	public void setParent( VOCLDiagram newParent ) {
		parent = newParent;
	}
	
	/**
	 * Sets the constraint.
	 * @param constraint the constraint to set
	 */
	public void setConstraint( Constraint constraint )
	{
		this.constraint = constraint;
	}
	
	/**
	 * Sets the location.
	 * @param loc the location to set
	 */
	public void setLocation (Point loc) {
		this.loc = loc;
	}	
}
