/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.commands;

import org.eclipse.gef.commands.Command;

import VOCLModel.*;

/**
 * Command for deleting a constraint.
 * @author bjoern
 */
public class DeleteConstraintCommand extends Command {
	private Constraint constraint;
	private VOCLDiagram diagram;

	/**
	 * Creates a new DeleteConstraintCommand.
	 * 
	 * @param constraint The VOCL Constraint to be deleted
	 */
	public DeleteConstraintCommand( Constraint constraint) {
		setLabel("delete constraint");
		this.constraint = constraint;
		this.diagram    = constraint.getDiagram();
	}
	
	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		diagram.getConstraints().remove( constraint );	
	}

	/**
	 * Redo command execution.
	 */
	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		diagram.getConstraints().add( constraint );	
	}	
}
