/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.commands;

import org.eclipse.draw2d.geometry.Rectangle;

import org.eclipse.emf.ecore.EObject;

import VOCLModel.BoolExp;
import VOCLModel.ClassifierRole;
import VOCLModel.Constraint;
import VOCLModel.VOCLExpression;


/**
 * Change the location of a graphical object.
 * 
 * @author (unknown), bjoern
 */
// TODO: create a Position Class in VOCLModel for Constraint, Command, ... and use that one instead of these
public class SetConstraintCommand extends org.eclipse.gef.commands.Command {
	private Rectangle newLocation = null;	
	private Rectangle oldLocation = null;	
	private EObject object;
	
	/**
	 * The default constructor.
	 */
	public SetConstraintCommand(){
		setLabel("resize/move");
	}
	
	/**
	 * Executes the command.
	 */
	public void execute() {
		if (object instanceof ClassifierRole) {
			ClassifierRole classifierrole = (ClassifierRole) object;
			if ( oldLocation == null )
				oldLocation  = new Rectangle( classifierrole.getX(), classifierrole.getY(), -1, -1 );
			classifierrole.setX(newLocation.x);
			classifierrole.setY(newLocation.y);			
		} 	
		if (object instanceof Constraint) {
			Constraint constraint = (Constraint) object;
			if ( oldLocation == null )
				oldLocation  = new Rectangle( constraint.getX(), constraint.getY(), constraint.getWidth(), constraint.getHeight() );
			constraint.setX(newLocation.x);
			constraint.setY(newLocation.y);
			constraint.setWidth(newLocation.width);
			constraint.setHeight(newLocation.height);
		}
		if (object instanceof VOCLExpression ) {
			VOCLExpression exp = (	VOCLExpression) object;
			if ( oldLocation == null )
				oldLocation  = new Rectangle( exp.getX(), exp.getY(), exp.getWidth(), exp.getHeight() );
			exp.setX(newLocation.x);
			exp.setY(newLocation.y);
			exp.setWidth(newLocation.width);
			exp.setHeight(newLocation.height);
		} 
	}
	
	/**
	 * Redo command execution.
	 */
	public void redo() {
		execute();
	}
	
	/**
	 * Sets the location.
	 * @param r the location to set
	 */
	public void setLocation(Rectangle r)
	{
		newLocation = r;
	}
	
	
	public void setObject(EObject object) {
		this.object = object;
	}
	
	/**
	 * Undo command execution.
	 */
	public void undo() {
		if (object instanceof ClassifierRole) {
			ClassifierRole classifierrole = (ClassifierRole) object;
			classifierrole.setX( oldLocation.x );
			classifierrole.setY( oldLocation.y );			
		} else if (object instanceof Constraint) {
			Constraint constraint = (Constraint) object;
			constraint.setX( oldLocation.x );
			constraint.setY( oldLocation.y );
			constraint.setWidth( oldLocation.width );
			constraint.setHeight( oldLocation.height );
		} else if (object instanceof BoolExp ) {
			BoolExp boolexp = (	BoolExp) object;
			boolexp.setX( oldLocation.x );
			boolexp.setY( oldLocation.y );
			boolexp.setWidth( oldLocation.width );
			boolexp.setHeight( oldLocation.height );
		} 
	}
	
}
