
package vocleditor.converter;

/**
 * XSLT Test
 */
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import vocleditor.VOCLEditorPlugin;

public class XSLTTest {

	public static void main(String[] args) {
		
			VOCLEditorPlugin.printDebug("Test XSLT...");
	 	// Use the static TransformerFactory.newInstance()
	        // method to instantiate // a TransformerFactory.
	        // The javax.xml.transform.TransformerFactory
	        // system property setting determines the actual class
	        // to instantiate -- org.apache.xalan.transformer.TransformerImpl.
	        TransformerFactory tFactory = TransformerFactory.newInstance();

	        // Use the TransformerFactory to instantiate
	        // a Transformer that will work with the stylesheet you specify.
	        // This method call also processes the stylesheet
	        // into a compiled Templates object.
	        try {
	        
	       	Transformer transformer =
	                tFactory.newTransformer(new StreamSource("src/vocleditor/converter/navexp2gxl.xsl"));
	       
	        	
	        	
	        // Use the Transformer to apply the associated Templates object
	        // to an XML document (foo.xml) and
	        // write the output to a file (foo.out).
	        transformer.transform(new StreamSource("src/vocleditor/converter/test1.vocl"),
	                new StreamResult(new FileOutputStream("src/vocleditor/converter/result.gxl")));

	        } catch (TransformerException ex) {System.err.println(ex.getLocalizedMessage());} 
	          catch (FileNotFoundException e) { e.printStackTrace();};

	}
}
