/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.edit;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import VOCLModel.*;

import vocleditor.commands.DeleteClassifierRoleCommand;
import vocleditor.commands.DeleteSetClassifierRoleCommand;

/**
 * EditPolicy for Connection Role.
 */
public class VOCLClassifierRoleComponentEditPolicy extends ComponentEditPolicy {
	
	public VOCLClassifierRoleComponentEditPolicy() {
		super();
	}
	
	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		Command result = null;
		
		NavExp parent = (NavExp) getHost().getParent().getModel();
		
		if( getHost().getModel() instanceof SetClassifierRole ) {
			DeleteSetClassifierRoleCommand deleteCmd = new DeleteSetClassifierRoleCommand();		
			deleteCmd.setParent(parent);
			deleteCmd.setSetClassifierRole((SetClassifierRole) getHost().getModel());
			result = deleteCmd;
		}else{
			DeleteClassifierRoleCommand deleteCmd = new DeleteClassifierRoleCommand();		
			deleteCmd.setParent(parent);
			deleteCmd.setClassifierRole((ClassifierRole) getHost().getModel());
			result = deleteCmd;
		}
	
		return result;
	}

}
