/*
 * Created on 28.05.2005
 *
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.edit;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PrecisionPoint;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.draw2d.IFigure;

/**
 * implements AbstractConnectionAnchor for Anchorpoints on ClassifierRoles
 */
public class VOCLConnectionAnchor extends AbstractConnectionAnchor {
	/**
	 * x offset for the anchor point
	 */
	private int xOffset;
	/**
	 * y offset for the anchor point
	 */
	private int yOffset;
	/**
	 * Constructor for Anchor
	 * 
	 */
	public VOCLConnectionAnchor() {
		super();
		xOffset = 0;
		xOffset = 0;
	}
	/**
	 * Constructor for Anchor
	 * @param owner ifigure
	 */
	public VOCLConnectionAnchor(IFigure owner) {
		super(owner);
		xOffset = 0;
		xOffset = 0;
	}
	/**
	 * @see org.eclipse.draw2d.ConnectionAnchor#getLocation(org.eclipse.draw2d.geometry.Point)
	 */
	public Point getLocation(Point arg0) {
		Rectangle r = getOwner().getBounds();
		int x,y;
		x = r.x + xOffset;
		y = r.y + yOffset;

		Point p = new PrecisionPoint(x,y);
		getOwner().translateToAbsolute(p);
		return p;
	}
	
	/**
	 * Set the offset for the point
	 * @param x new x offset
	 * @param y new y offset
	 */
	public void setOffset(int x, int y) {
		xOffset = x;
		yOffset = y;
	}

	/**
	 * Getter for the x offset
	 * @return x offset
	 */
	public int getxOffset(){
		return xOffset;
	}

	/**
	 * Getter for the y offset
	 * @return y offset
	 */
	public int getyOffset(){
		return yOffset;
	}

	/**
	 * @see org.eclipse.draw2d.ConnectionAnchor#getReferencePoint()
	 */
	public Point getReferencePoint(){
		return getLocation(null);
	}
}
