/*
 * VOCLEditor PlugIn for Eclipse
 *
 * Gruppe 4 - Sommersemester 2005  
 */
package vocleditor.figures;

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;

import vocleditor.VOCLEditorConstants;

/**
 * The condition figure class.
 * 
 * @author manaljav
 */
public class ConditionFigure extends Label{
	
	/**
	 * Creates a new ConditionFigure
	 */
	public ConditionFigure() 
	{
	    setOpaque(true);
	    setSize(50, 20);
	    setBounds( new Rectangle( 0, 0, 100, 20 ) );
	}

	/**
	 * Called by the EditPart to set label background after selection state change.
	 * @param selected SELECTED_PRIMARY, SELECTED, or SELECTED_NONE from GEF.EditPart
	 */
	public void setSelected( int selected )	{
		if ( selected == EditPart.SELECTED_PRIMARY )  {
			setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_SELECTED_PRIMARY_COLOR  );
		}
		else if ( selected == EditPart.SELECTED )  {
			setBackgroundColor( VOCLEditorConstants.ATTRIBUTE_SELECTED_COLOR  );
		}
		else {
			if ( getParent().getChildren().indexOf( this ) % 2 == 0 )
				setBackgroundColor( VOCLEditorConstants.CONDITION_COLOR );
			else
				setBackgroundColor( VOCLEditorConstants.CONDITION_COLOR_2 );
		}
		repaint();
	}
	
	/**
	 * Sets the background color after being added to a parent figure.
	 */
	public void addNotify() {
		setBackgroundColor( VOCLEditorConstants.CONDITION_COLOR );
		super.addNotify();
	}
}
