/**
 * <copyright>
 * </copyright>
 *
 * $Id: AssociationRole.java,v 1.22 2005/07/07 08:31:02 bjoernt Exp $
 */
package VOCLModel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Association Role</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link VOCLModel.AssociationRole#getAssociationTarget <em>Association Target</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getAssociationSource <em>Association Source</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getBendpointsFirstWidthList <em>Bendpoints First Width List</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getBendpointsFirstHeightList <em>Bendpoints First Height List</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getBendpointsSecondHeightList <em>Bendpoints Second Height List</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getBendpointsSecondWidthList <em>Bendpoints Second Width List</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getRoutingType <em>Routing Type</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getSourceAnchorAt <em>Source Anchor At</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getTargetAnchorAt <em>Target Anchor At</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getNavExp <em>Nav Exp</em>}</li>
 *   <li>{@link VOCLModel.AssociationRole#getLabelDecoration <em>Label Decoration</em>}</li>
 * </ul>
 * </p>
 *
 * @see VOCLModel.VOCLModelPackage#getAssociationRole()
 * @model
 * @generated
 */
public interface AssociationRole extends ModelElement{
  /**
   * Returns the value of the '<em><b>Association Target</b></em>' reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.ClassifierRole#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Association Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Association Target</em>' reference.
   * @see #setAssociationTarget(ClassifierRole)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_AssociationTarget()
   * @see VOCLModel.ClassifierRole#getSource
   * @model opposite="source" required="true"
   * @generated
   */
	ClassifierRole getAssociationTarget();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getAssociationTarget <em>Association Target</em>}' reference.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Association Target</em>' reference.
   * @see #getAssociationTarget()
   * @generated
   */
	void setAssociationTarget(ClassifierRole value);

  /**
   * Returns the value of the '<em><b>Association Source</b></em>' reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.ClassifierRole#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Association Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Association Source</em>' reference.
   * @see #setAssociationSource(ClassifierRole)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_AssociationSource()
   * @see VOCLModel.ClassifierRole#getTarget
   * @model opposite="target" required="true"
   * @generated
   */
	ClassifierRole getAssociationSource();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getAssociationSource <em>Association Source</em>}' reference.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Association Source</em>' reference.
   * @see #getAssociationSource()
   * @generated
   */
	void setAssociationSource(ClassifierRole value);

  /**
   * Returns the value of the '<em><b>Bendpoints First Width List</b></em>' attribute list.
   * The list contents are of type {@link java.lang.Integer}.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bendpoints First Width List</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Bendpoints First Width List</em>' attribute list.
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_BendpointsFirstWidthList()
   * @model type="int" unique="false"
   * @generated
   */
	EList getBendpointsFirstWidthList();

  /**
   * Returns the value of the '<em><b>Bendpoints First Height List</b></em>' attribute list.
   * The list contents are of type {@link java.lang.Integer}.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bendpoints First Height List</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Bendpoints First Height List</em>' attribute list.
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_BendpointsFirstHeightList()
   * @model type="int" unique="false"
   * @generated
   */
	EList getBendpointsFirstHeightList();

  /**
   * Returns the value of the '<em><b>Bendpoints Second Height List</b></em>' attribute list.
   * The list contents are of type {@link java.lang.Integer}.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bendpoints Second Height List</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Bendpoints Second Height List</em>' attribute list.
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_BendpointsSecondHeightList()
   * @model type="int" unique="false"
   * @generated
   */
	EList getBendpointsSecondHeightList();

  /**
   * Returns the value of the '<em><b>Bendpoints Second Width List</b></em>' attribute list.
   * The list contents are of type {@link java.lang.Integer}.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bendpoints Second Width List</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Bendpoints Second Width List</em>' attribute list.
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_BendpointsSecondWidthList()
   * @model type="int" unique="false"
   * @generated
   */
	EList getBendpointsSecondWidthList();

  /**
   * Returns the value of the '<em><b>Routing Type</b></em>' attribute.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Routing Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Routing Type</em>' attribute.
   * @see #setRoutingType(byte)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_RoutingType()
   * @model
   * @generated
   */
	byte getRoutingType();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getRoutingType <em>Routing Type</em>}' attribute.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Routing Type</em>' attribute.
   * @see #getRoutingType()
   * @generated
   */
	void setRoutingType(byte value);

  /**
   * Returns the value of the '<em><b>Source Anchor At</b></em>' attribute.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source Anchor At</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Source Anchor At</em>' attribute.
   * @see #setSourceAnchorAt(int)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_SourceAnchorAt()
   * @model
   * @generated
   */
	int getSourceAnchorAt();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getSourceAnchorAt <em>Source Anchor At</em>}' attribute.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source Anchor At</em>' attribute.
   * @see #getSourceAnchorAt()
   * @generated
   */
	void setSourceAnchorAt(int value);

  /**
   * Returns the value of the '<em><b>Target Anchor At</b></em>' attribute.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target Anchor At</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Target Anchor At</em>' attribute.
   * @see #setTargetAnchorAt(int)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_TargetAnchorAt()
   * @model
   * @generated
   */
	int getTargetAnchorAt();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getTargetAnchorAt <em>Target Anchor At</em>}' attribute.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Anchor At</em>' attribute.
   * @see #getTargetAnchorAt()
   * @generated
   */
	void setTargetAnchorAt(int value);

  /**
   * Returns the value of the '<em><b>Nav Exp</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.NavExp#getAssociationRoles <em>Association Roles</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Nav Exp</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Nav Exp</em>' container reference.
   * @see #setNavExp(NavExp)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_NavExp()
   * @see VOCLModel.NavExp#getAssociationRoles
   * @model opposite="associationRoles" required="true"
   * @generated
   */
	NavExp getNavExp();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getNavExp <em>Nav Exp</em>}' container reference.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Nav Exp</em>' container reference.
   * @see #getNavExp()
   * @generated
   */
	void setNavExp(NavExp value);

  /**
   * Returns the value of the '<em><b>Label Decoration</b></em>' containment reference.
   * It is bidirectional and its opposite is '{@link VOCLModel.Label#getAssociationRole <em>Association Role</em>}'.
   * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Label Decoration</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
   * @return the value of the '<em>Label Decoration</em>' containment reference.
   * @see #setLabelDecoration(Label)
   * @see VOCLModel.VOCLModelPackage#getAssociationRole_LabelDecoration()
   * @see VOCLModel.Label#getAssociationRole
   * @model opposite="associationRole" containment="true" required="true"
   * @generated
   */
	Label getLabelDecoration();

  /**
   * Sets the value of the '{@link VOCLModel.AssociationRole#getLabelDecoration <em>Label Decoration</em>}' containment reference.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @param value the new value of the '<em>Label Decoration</em>' containment reference.
   * @see #getLabelDecoration()
   * @generated
   */
	void setLabelDecoration(Label value);

} // AssociationRole
